# Copyright (c) 2000-2005, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define bname	mockobjects
%define section		free

Name:		mockobjects010
Version:	0.10dev
Release:	0.20060313.1jpp
Epoch:		0
Summary:	Java MockObjects package
License:	BSD Style
URL:		http://www.mockobjects.com/
Group:		Development/Testing
Vendor:         JPackage Project
Distribution:   JPackage
Source0:	http://www.mockobjects.com/dist/%{bname}-%{version}.tar.gz
# patch to current junit
Patch0:		mockobjects-AssertMo.patch
# patch to current j-c-httpclient
Patch1:		mockobjects-MockPutMethod.patch
# patch to J2EE-1.4
# JMS
Patch2:		mockobjects-MockBytesMessage.patch
Patch3:		mockobjects-MockConnection.patch
Patch4:		mockobjects-MockMessagePublisher.patch
Patch5:		mockobjects-MockQueueConnectionFactory.patch
Patch6:		mockobjects-MockQueueSender.patch
Patch7:		mockobjects-MockSession.patch
Patch8:		mockobjects-MockTopicConnectionFactory.patch

Requires:	junit
Requires:	/usr/sbin/update-alternatives
BuildRequires:	ant >= 1.6
BuildRequires:	ant-junit
BuildRequires:	jakarta-commons-httpclient
BuildRequires:	java-devel >= 1.4.0
BuildRequires:	java-devel < 1.5
BuildRequires:	junit
BuildRequires:	geronimo-j2ee-1.4-apis
BuildArch:	noarch
BuildRoot:	%{_tmppath}/%{bname}-%{version}-%{release}-buildroot

%description
The Mock Objects project is a generic unit testing framework whose goal
is to facilitate developing unit tests in the mock object style. The
goal of this project is to provide, a core mock objects framework. This
is a library of code that supports the implementation of mock objects.
It is based around a set of expectation classes for values and
collections. There are also various other classes to make mock objects
easier to write or to use.

%package jdk1.4
Summary:	MockObjects for 1.4 JDK
Group:		Development/Testing
Requires:	/usr/sbin/update-alternatives
Requires:	%{name} = %{epoch}:%{version}-%{release}
Requires:	java-devel >= 1.4
Requires:	java-devel < 1.5

%description jdk1.4
MockObjects specific to JDK 1.4.x

%package httpclient
Summary:	MockObjects for Commons HttpClient
Group:		Development/Testing
Requires:	%{name} = %{epoch}:%{version}-%{release}
Requires:	/usr/sbin/update-alternatives
Requires:	jakarta-commons-httpclient

%description httpclient
MockObjects for Jakarta Commons HttpClient

%package alt-httpclient
Summary:        Mockable API for Commons HttpClient
Group:          Development/Testing
Requires:       /usr/sbin/update-alternatives
Requires:	%{name} = %{epoch}:%{version}-%{release}
Requires:	%{name}-httpclient = %{epoch}:%{version}-%{release}
Requires:	jakarta-commons-httpclient

%description alt-httpclient
Alternative API for Jakarta Commons HttpClient to allow for testing

%package alt-jdk1.4
Summary:        Mockable API for JDK 1.4
Group:          Development/Testing
Requires:	%{name} = %{epoch}:%{version}-%{release}
Requires:	%{name}-jdk1.4 = %{epoch}:%{version}-%{release}
Requires:	java-devel >= 1.4
Requires:	java-devel < 1.5

%description alt-jdk1.4
Alternative API for JDK 1.4 to allow for testing

%package jdk1.4-j2ee1.4
Summary:        Mockable J2EE API for JDK 1.4 and J2EE 1.4
Group:          Development/Testing
Requires:	%{name} = %{epoch}:%{version}-%{release}
Requires:	%{name}-jdk1.4 = %{epoch}:%{version}-%{release}
Requires:	java-devel >= 1.4
Requires:	java-devel < 1.5

%description jdk1.4-j2ee1.4
API for JDK 1.4 to allow testing with J2EE 1.4 mocks

%prep
%setup -q -n %{bname}-%{version}
%patch0 -b .sav
%patch1 -b .sav
%patch2 -b .sav
%patch3 -b .sav
%patch4 -b .sav
%patch5 -b .sav
%patch6 -b .sav
%patch7 -b .sav
%patch8 -b .sav

%build

# build with (almost) empty CLASSPATH
CLASSPATH=`build-classpath junit` ant -buildfile build.xml -Dbuild.compiler=modern jar-core

#JVM extensions

for vm in 0 1 2; do
    if [ -e %{_jvmdir}/java-1.4.${vm}/bin/javac ]; then
	VM_14=${vm}
    fi
done

CLASSPATH=`build-classpath junit` JAVA_HOME=%{_jvmdir}/java-1.4.${VM_14} ant -buildfile build.xml -Dbuild.compiler=modern jar-jdk

#Httpclient extensions
CLASSPATH=`build-classpath jakarta-commons-httpclient junit` ant jar-ext-httpclient

rm -rf out/j2ee/classes/*
CLASSPATH=`build-classpath geronimo-j2ee-1.4-apis junit` JAVA_HOME=%{_jvmdir}/java-1.4.${VM_14} ant -buildfile build.xml -Dbuild.compiler=modern -Djdk.version=1.4 -Dj2ee.version=1.4 compile-j2ee jar-j2ee

%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
mkdir -p $RPM_BUILD_ROOT%{_javadir}{-1.4.0,-1.4.1,-1.4.2}
mkdir -p $RPM_BUILD_ROOT%{_javadir}-ext/%{name}-{,alt-}jdk1.4

pushd out
install -m 644 %{bname}-core-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-core-%{version}.jar
install -m 644 %{bname}-httpclient.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-httpclient-%{version}.jar
install -m 644 alt-httpclient.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-alt-httpclient-%{version}.jar

# Install JDK Mocks and alternatives
install -m 644 %{bname}-jdk1.4-%{version}.jar $RPM_BUILD_ROOT%{_javadir}-ext/%{name}-jdk1.4/%{name}-%{version}.jar
install -m 644 %{bname}-alt-jdk1.4-%{version}.jar $RPM_BUILD_ROOT%{_javadir}-ext/%{name}-alt-jdk1.4/%{name}-alt-%{version}.jar

# Install J2EE Mocks

install -m 644 %{bname}-jdk1.4-j2ee1.4-%{version}.jar $RPM_BUILD_ROOT%{_javadir}-ext/%{name}-jdk1.4/%{name}-j2ee1.4-%{version}.jar

popd

pushd $RPM_BUILD_ROOT%{_javadir} 
for jar in *-%{version}.jar; do
	ln -sf ${jar} $(echo $jar| sed "s|-%{version}||g")
done
popd

pushd $RPM_BUILD_ROOT%{_javadir}-ext/%{name}-jdk1.4
for jar in *-%{version}.jar; do
	ln -sf ${jar} $(echo $jar| sed "s|-%{version}||g")
done
popd

pushd $RPM_BUILD_ROOT%{_javadir}-ext/%{name}-alt-jdk1.4
for jar in *-%{version}.jar; do
	ln -sf ${jar} $(echo $jar| sed "s|-%{version}||g")
done
popd


for EXTENSION_VM in 1.4.0 1.4.1 1.4.2; do
   EXTENSION_PREFIX=$(echo $EXTENSION_VM | sed -e 's/1\.\([4]\)\.[0-9]/1.\1/')
   pushd $RPM_BUILD_ROOT%{_javadir}-${EXTENSION_VM}
      ln -sf %{_javadir}-ext/%{name}-jdk${EXTENSION_PREFIX}/%{name}-%{version}.jar  .
      ln -sf %{_javadir}-ext/%{name}-alt-jdk${EXTENSION_PREFIX}/%{name}-alt-%{version}.jar .
      ln -sf %{_javadir}-ext/%{name}-jdk${EXTENSION_PREFIX}/%{name}-j2ee1.4-%{version}.jar  .
      for jar in *-%{version}.jar; do
         ln -sf ${jar} $(echo $jar| sed "s|-%{version}||g")
      done
    popd
done

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%post

%postun

%files
%defattr(0644,root,root,0755)
%doc doc/README
%{_javadir}/%{name}-core*

%files jdk1.4
%defattr(0644,root,root,0755)
%{_javadir}-ext/%{name}-jdk1.4/%{name}-%{version}.jar
%{_javadir}-ext/%{name}-jdk1.4/%{name}.jar
%{_javadir}-1.4.0/%{name}-%{version}.jar
%{_javadir}-1.4.0/%{name}.jar
%{_javadir}-1.4.1/%{name}-%{version}.jar
%{_javadir}-1.4.1/%{name}.jar
%{_javadir}-1.4.2/%{name}-%{version}.jar
%{_javadir}-1.4.2/%{name}.jar

%files httpclient
%defattr(0644,root,root,0755)
%{_javadir}/%{name}-httpclient*

%files alt-jdk1.4
%defattr(0644,root,root,0755)
%{_javadir}-ext/%{name}-alt-jdk1.4/*
%{_javadir}-1.4.0/%{name}-alt-%{version}.jar
%{_javadir}-1.4.0/%{name}-alt.jar
%{_javadir}-1.4.1/%{name}-alt-%{version}.jar
%{_javadir}-1.4.1/%{name}-alt.jar
%{_javadir}-1.4.2/%{name}-alt-%{version}.jar
%{_javadir}-1.4.2/%{name}-alt.jar

%files alt-httpclient
%defattr(0644,root,root,0755)
%{_javadir}/%{name}-alt-httpclient*

%files jdk1.4-j2ee1.4
%defattr(0644,root,root,0755)
%{_javadir}-ext/%{name}-jdk1.4/%{name}-j2ee1.4-%{version}.jar
%{_javadir}-ext/%{name}-jdk1.4/%{name}-j2ee1.4.jar
%{_javadir}-1.4.0/%{name}-j2ee1.4-%{version}.jar
%{_javadir}-1.4.0/%{name}-j2ee1.4.jar
%{_javadir}-1.4.1/%{name}-j2ee1.4-%{version}.jar
%{_javadir}-1.4.1/%{name}-j2ee1.4.jar
%{_javadir}-1.4.2/%{name}-j2ee1.4-%{version}.jar
%{_javadir}-1.4.2/%{name}-j2ee1.4.jar

%changelog
* Wed Jun 07 2006 Fernando Nasser <fnasser@redhat.com> 0.10-0.20060313.1jpp
- Rename as many packages still need the 0.09 version and this is not
  even a release yet

* Fri May 05 2006 Ralph Apel <r.apel at r-apel.de> 0.10-0.20060313.1jpp
- Upgrade to 0.10 snapshot
- Build only J2EE1.4 support
- This is a brute force patch: FIXME

* Thu Sep 23 2004 Ralph Apel <r.apel at r-apel.de> 0.09-11jpp
- Optionally activate j2ee mockobjects

* Mon Aug 23 2004 Fernando Nasser <fnasser@redhat.com> 0.09-10jpp
- Remove support for 1.3 SDK
- Rebuild with Ant 1.6.2

* Tue May 18 2004 Paul Nasrat <pauln@truemesh.com> 0.09-9jpp
- Fix spurious 1.4.1 requires in jdk14

* Thu Jun 26 2003 Paul Nasrat <pauln@truemesh.com> 0.09-8jpp
- Re-jigged alt/jvm symlinks to jars rather than dirs

* Tue Jun 24 2003 Paul Nasrat <pauln@truemesh.com> 0.09-7jpp
- Multi jvm symlinks

* Thu Jun 19 2003 Paul Nasrat <pauln@truemesh.com> 0.09-6jpp
- Use java-ext for JDK specific extensions/alternatives

* Thu Jun 19 2003 Paul Nasrat <pauln@truemesh.com> 0.09-5jpp
- Split alternative APIs - as advised by Jeff Martin

* Wed Jun 18 2003 Paul Nasrat <pauln@truemesh.com> 0.09-4jpp
- BuildRequires sdk rather than jdk

* Wed Jun 18 2003 Paul Nasrat <pauln@truemesh.com> 0.09-3jpp
- BuildRequires multiple jdk

* Wed Jun 18 2003 Paul Nasrat <pauln@truemesh.com> 0.09-2jpp
- Broken up into subpackages
- Patch to build jdk-jar (commited upstream)
- Patch to build httpclient (discussed with upstream)

* Wed Mar 05 2003 Jeff Martin <jeff@custommonkey.org> 0.08-1
- first release
